/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.ups.testcases.push.scu;
import java.util.Scanner;

import cdac.medinfo.sdk.dcm30_04.baselibs.DataSet;
import cdac.medinfo.sdk.dcm30_04.baselibs.DicomV3Factory;
import cdac.medinfo.sdk.dcm30_04.baselibs.ImplicitDE;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataTypeSQ;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumModality;
import cdac.medinfo.sdk.dcm30_04.enums.EnumPDUType;
import cdac.medinfo.sdk.dcm30_04.enums.EnumSOPClassUIDs;
import cdac.medinfo.sdk.dcm30_04.services.association.AAbort;
import cdac.medinfo.sdk.dcm30_04.services.association.AReleaseRQorRP;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociateRQ;
import cdac.medinfo.sdk.dcm30_04.services.association.DefaultAssociation;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumActionTypeID;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumServiceType;
import cdac.medinfo.sdk.dcm30_04.services.naction.commons.NActionRQ;
import cdac.medinfo.sdk.dcm30_04.services.naction.commons.NActionRSP;
import cdac.medinfo.sdk.dcm30_04.services.ncreate.commons.NCreateRQ;
import cdac.medinfo.sdk.dcm30_04.services.ncreate.commons.NCreateRSP;
import cdac.medinfo.sdk.dcm30_04.services.scu.commons.SCUSession;
import cdac.medinfo.sdk.dcm30_04.services.ups.scu.UPS_SCU;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;

/**
* This sample code specifies the role of UPS Push service class user for UPS SOP Class.
*/

public class UPS_Push_NCreate_SCU 
{

	public static void main(String[] args)
	{
		DicomConfig objDicomConfig = DicomConfig.createInstance();

		//enable logging,specify the path of the directory where log files are created.
		//User can specify any directory in place of 'c:\DCM_Logs'.
		//If no directory is defined by user to create logs then it is created in User Temp DIR.
		objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "C:\\DCM_Logs");

		/*
		 * Creates instance of UPS_SCU_Test
		 */
		UPS_Push_NCreate_SCU objTestUPS_SCU = new UPS_Push_NCreate_SCU();

		/*
		 * Performs operation of UPS Services 
		 */
		objTestUPS_SCU.doUPS();
	}
	
	/**
	 * This function performs the operation for all supported services of UPS
	 * UPS operation involves following steps :-
	 * 1. Establish the connection with SCP
	 * 2. Establish the association with SCP
	 * 3. Initializes the SCU for corresponding N-Service and performs the operation using service request
	 * 4. Releases the association after successful processing of service request
	 * 5. Closes the connection with SCP. 
	 */
	public void doUPS()
	{
		Scanner sc = new Scanner(System.in);
		try
		{
			/*
			 * *************************************************************************
			 * This block of code performs the connection process with SCP.
			 * It creates the SCUSession and connects with SCP using this session.
			 * *************************************************************************
			 */
			//Create SCUSession object
			SCUSession objSession = new SCUSession();
			
			/*
			 * Setting time out as 5000 milli second. It will wait 5000 mili seconds for read and write operation.
			 * If in the time specified (5000 ms) read or write operation is not performed then 
			 * session is time out.
			 */ 
			//objSession.setTimeOut(5000);
			
			//Start SCU Session by providing the IP address and Port of SCP.
			objSession.start("localhost", 9000);

			/*
			 * *************************************************************************
			 * This block of code initializes the DefaultAssociation information
			 * Using the DefaultAssociation it generates the Association Request and 
			 * creates association  with SCP.
			 * *************************************************************************
			 */

			// Initializes the service types and populates the Default Association
			EnumServiceType[] arrenumServiceType = new EnumServiceType[2];
			arrenumServiceType[0] = EnumServiceType.NCREATE_UPS;
			arrenumServiceType[1] = EnumServiceType.NACTION_UPS;
			DefaultAssociation objDefaultAssociation = new DefaultAssociation("SDK");
			objDefaultAssociation.loadAssociation(arrenumServiceType);

			//Create Association RQ
			AssociateRQ objAssociateRQ = objDefaultAssociation.getAssociationRQ("SDK");

			//Send the Association Request
			if(objSession.sendAssociationMessage(objAssociateRQ))
			{	
				//When association is successfully established the "objSession.sendAssociationMessage()" method returns true.
				System.out.println("Association established");

				/*
				 * *************************************************************************
				 * This block of code creates the UPS SCU to perform the process of 
				 * SOP Instance creation operation for UPS.
				 * It initializes the NCreate RQ and sends it to SCP.
				 * *************************************************************************
				 */
				//Create UPS SCU object using the current SCU Session.
				UPS_SCU objUPS_SCU = new UPS_SCU(objSession);

				//Generating Dataset for UPS
				IDataSet objUPSDataSet = getUPSForCreate();
				//Initializing NCreate RQ 
				NCreateRQ objNCreateRQ = NCreateRQ.getDefaultRQ(EnumSOPClassUIDs.DCM_UPS_PUSH.getValue(), "1.2.840.10008.5.1.4.34.6.1", objUPSDataSet);
				System.out.println("UPS Request For N-Create Initialized");

				//sending RQ to SCP
				if(objUPS_SCU.sendMessage(objNCreateRQ)) //sending request
				{
					System.out.println("UPS Instance Creation Operation performed");
					NCreateRSP objNCreateRSP = new NCreateRSP(objUPS_SCU.getDIMSEResponse().get(0));
					System.out.println("N-Create Response Status :" + objNCreateRSP.getStatus());
				}
				else
					System.out.println("UPS Instance Creation Operation failed");
				
				System.out.println("Do you Want to Cancel Instance Created :");
				System.out.println("\n1.Yes \t 2. No");
				if(sc.nextInt()==1)
				{
					/*
					 * *************************************************************************
					 * This block of code creates the NAction SCU to perform the process of UPS.
					 * It initializes the NAction RQ and sends it to SCP.
					 * *************************************************************************
					 */
					objUPSDataSet= getUPSForAction();
					
					//Initializing NAction RQ for same SOP Instance to initiate the operation
					NActionRQ objNActionInitiateRQ = NActionRQ.getDefaultRQ(EnumSOPClassUIDs.DCM_UPS_PUSH.getValue(), "1.2.840.10008.5.1.4.34.6.1",EnumActionTypeID.UPS_CANCEL,objUPSDataSet);
					System.out.println("N-Action Request for UPS initialized");

					//sending RQ to SCP
				
					if(objUPS_SCU.sendMessage(objNActionInitiateRQ)) //sending request
					{
						System.out.println("Initiate Operation for NACTION");
						
						NActionRSP objNActionRSP = new NActionRSP(objUPS_SCU.getDIMSEResponse().get(0));
						System.out.println("N-Action Response Status :" + objNActionRSP.getStatus());
					}
					else
						System.out.println("Initiate Operation failed for NACTION");
				}
				

				/*
				 * *************************************************************************
				 * This block of code releases the association and 
				 * removes the connection with SCP.  
				 * *************************************************************************
				 */
				//Create A-Release-RQ to release the association
				AReleaseRQorRP objAReleaseRQorRP = new AReleaseRQorRP(EnumPDUType.RELEASE_RQ);

				//Send the A-Release-RQ
				if(objSession.sendAssociationMessage(objAReleaseRQorRP))
				{
					System.out.println("Association is released");
					//When successful A-Release-RP is received, close the Session.
					//Please note that instead of closing the session we can create 
					//another association and send more requests. Also it is possible
					//to create multiple N-Service-RQs and send them one by one.
					objSession.close();
				}

				//In case an ABORT is received from SCP during the UPS operation
				if(objSession.getDIMSEAssociation() instanceof AAbort)
				{
					System.out.println("Abort arrives. Closing session.");
					objSession.close();
				}
			}
			else
			{
				System.out.println("Association cannot to extablished");
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	private IDataSet getUPSForAction() {
				IDataSet objIDataSet = new DataSet();
				IDictionaryReader objDictionaryReader = objIDataSet.getDictionaryReader();
				//Transaction UID
			//	objIDataSet.addDataElement(getDataElement(0x0008,0x1195, "1.1", objDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0074,0x1000,"CANCLE" , objDictionaryReader));
		return objIDataSet;
	}

	private IDataSet getUPSForCreate() {
		IDataSet objIDataSet = new DataSet();
		IDictionaryReader objDictionaryReader = objIDataSet.getDictionaryReader();
		ITransferSyntax objTS = objIDataSet.getTransferSyntax();
		//SOP Common Module
		String []arrSpecificCharSet = new String[1];
		arrSpecificCharSet[0] = "ISO 2022 IR 87";
		objIDataSet.addDataElement(getDataElement(0x0008,0x0005, arrSpecificCharSet, objDictionaryReader));
		//Transaction UID
		objIDataSet.addDataElement(getDataElement(0x0008,0x1195, "1.1", objDictionaryReader));
	
		//Scheduled Procedure Step
		{
			IDataTypeSQ objScheduledProcedureStepSQ = getSQ(0x0040,0x0100,objTS);
			IItem objScheduledProcedureStepItem = objScheduledProcedureStepSQ.getNewItem();
			String []strAETitle = new String[2];
			strAETitle[0] = "C";
			strAETitle[1] = "D";
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0001,strAETitle, objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0002,"20000910", objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0003,"112000.000000", objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0008,0x0060,EnumModality.COMPUTED_RADIOGRAPHY.getValue(), objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0006,"Physician Name", objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0007,"Description", objDictionaryReader));
			String []strStationName = new String[2];
			strStationName[0] = "TABLET1";
			strStationName[1] = "TABLET2";
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0010,strStationName, objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0011,"Location", objDictionaryReader));
			{
				IDataTypeSQ objScheduledProtocolCodeSQ = getSQ(0x0040,0x0008, objTS);
				IItem objScheduledProtocolCodeItem = objScheduledProtocolCodeSQ.getNewItem();
				objScheduledProtocolCodeItem.addDataElement(getDataElement(0x0008,0x0100,"T-04000", objDictionaryReader));
				objScheduledProtocolCodeItem.addDataElement(getDataElement(0x0008,0x0102,"C4", objDictionaryReader));
				objScheduledProtocolCodeItem.addDataElement(getDataElement(0x0008,0x0103,"CPT-4", objDictionaryReader));
				objScheduledProtocolCodeItem.addDataElement(getDataElement(0x0008,0x0104,"Code Meaning", objDictionaryReader));
				{
					IDataTypeSQ objProtocolContextSQ = getSQ(0x0040,0x0440, objTS);
					IItem objProtocolContextItem = objProtocolContextSQ.getNewItem();
					objProtocolContextItem.addDataElement(getDataElement(0x0040,0xA040,"Value Type", objDictionaryReader));
					{
						IDataTypeSQ objConceptNameCodeSQ = getSQ(0x0040,0xA043, objTS);
						IItem objConceptNameCodeItem = objConceptNameCodeSQ.getNewItem();
						objConceptNameCodeItem.addDataElement(getDataElement(0x0008,0x0100,"T-04000", objDictionaryReader));
						objConceptNameCodeItem.addDataElement(getDataElement(0x0008,0x0102,"C4", objDictionaryReader));
						objConceptNameCodeItem.addDataElement(getDataElement(0x0008,0x0103,"CPT-4", objDictionaryReader));
						objConceptNameCodeItem.addDataElement(getDataElement(0x0008,0x0104,"Code Meaning", objDictionaryReader));
						objConceptNameCodeSQ.addItem(objConceptNameCodeItem);

						objProtocolContextItem.addDataElement(getDataElement(0x0040,0xA043,objConceptNameCodeSQ.getValue(), objDictionaryReader));
					}
					objProtocolContextItem.addDataElement(getDataElement(0x0040,0xA120,"20000910101010", objDictionaryReader));
					objProtocolContextItem.addDataElement(getDataElement(0x0040,0xA123,"Person Name", objDictionaryReader));
					objProtocolContextItem.addDataElement(getDataElement(0x0040,0xA160,"Text Value", objDictionaryReader));
					{
						IDataTypeSQ objConceptCodeSQ = getSQ(0x0040,0xA168, objTS);
						IItem objConceptCodeItem = objConceptCodeSQ.getNewItem();
						objConceptCodeItem.addDataElement(getDataElement(0x0008,0x0100,"T-04000", objDictionaryReader));
						objConceptCodeItem.addDataElement(getDataElement(0x0008,0x0102,"C4", objDictionaryReader));
						objConceptCodeItem.addDataElement(getDataElement(0x0008,0x0103,"CPT-4", objDictionaryReader));
						objConceptCodeItem.addDataElement(getDataElement(0x0008,0x0104,"Code Meaning", objDictionaryReader));
						objConceptCodeSQ.addItem(objConceptCodeItem);

						objProtocolContextItem.addDataElement(getDataElement(0x0040,0xA168,objConceptCodeSQ.getValue(), objDictionaryReader));
					}
					String []strNumericValue = new String[2];
					strNumericValue[0] = "1";
					strNumericValue[0] = "2";
					objProtocolContextItem.addDataElement(getDataElement(0x0040,0xA30A,strNumericValue, objDictionaryReader));
					{
						IDataTypeSQ objMeasurementUnitsCodeSQ = getSQ(0x0040,0x08EA, objTS);
						IItem objMeasurementUnitsCodeItem = objMeasurementUnitsCodeSQ.getNewItem();
						objMeasurementUnitsCodeItem.addDataElement(getDataElement(0x0008,0x0100,"T-04000", objDictionaryReader));
						objMeasurementUnitsCodeItem.addDataElement(getDataElement(0x0008,0x0102,"C4", objDictionaryReader));
						objMeasurementUnitsCodeItem.addDataElement(getDataElement(0x0008,0x0103,"CPT-4", objDictionaryReader));
						objMeasurementUnitsCodeItem.addDataElement(getDataElement(0x0008,0x0104,"Code Meaning", objDictionaryReader));
						objMeasurementUnitsCodeSQ.addItem(objMeasurementUnitsCodeItem);

						objProtocolContextItem.addDataElement(getDataElement(0x0040,0x08EA,objMeasurementUnitsCodeSQ.getValue(), objDictionaryReader));
					}
					objProtocolContextSQ.addItem(objProtocolContextItem);

					objScheduledProtocolCodeItem.addDataElement(getDataElement(0x0040,0x0440, objProtocolContextSQ.getValue(), objDictionaryReader));
				}
				objScheduledProtocolCodeSQ.addItem(objScheduledProtocolCodeItem);

				objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0008, objScheduledProtocolCodeSQ.getValue(), objDictionaryReader));
			}
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0012,"Pre Medication", objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0009,"STEPID", objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0032,0x1070,"Requested Contrast Agent", objDictionaryReader));
			objScheduledProcedureStepItem.addDataElement(getDataElement(0x0040,0x0020,"SCHEDULED Pro", objDictionaryReader));

			objScheduledProcedureStepSQ.addItem(objScheduledProcedureStepItem);

			objIDataSet.addDataElement(getDataElement(0x0040,0x0100,objScheduledProcedureStepSQ.getValue(), objDictionaryReader));
		}

		//Requested Procedure
		objIDataSet.addDataElement(getDataElement(0x0040,0x1001, "0", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0032,0x1060, "Requested Proced", objDictionaryReader));
		{
			IDataTypeSQ objRequestedProcedureCodeSQ = getSQ(0x0032,0x1064, objTS);
			IItem objRequestedProcedureCodeItem = objRequestedProcedureCodeSQ.getNewItem();
			objRequestedProcedureCodeItem.addDataElement(getDataElement(0x0008,0x0100,"T-04000", objDictionaryReader));
			objRequestedProcedureCodeItem.addDataElement(getDataElement(0x0008,0x0102,"C4", objDictionaryReader));
			objRequestedProcedureCodeItem.addDataElement(getDataElement(0x0008,0x0103,"CPT-4", objDictionaryReader));
			objRequestedProcedureCodeItem.addDataElement(getDataElement(0x0008,0x0104,"Code Meaning", objDictionaryReader));
			objRequestedProcedureCodeSQ.addItem(objRequestedProcedureCodeItem);

			objIDataSet.addDataElement(getDataElement(0x0032,0x1064,objRequestedProcedureCodeSQ.getValue(), objDictionaryReader));
		}
		objIDataSet.addDataElement(getDataElement(0x0020,0x000D, "1.2.840.10008.5.1.4.31", objDictionaryReader));
		{
			IDataTypeSQ objReferencedStudySQ = getSQ(0x0008,0x1110, objTS);
			IItem objReferencedStudyItem = objReferencedStudySQ.getNewItem();
			objReferencedStudyItem.addDataElement(getDataElement(0x0008,0x1150,"1.2.840.10008.5.1.4.31", objDictionaryReader));
			objReferencedStudyItem.addDataElement(getDataElement(0x0008,0x1155,"1.3.46.670589.17.1.7.1.1.11", objDictionaryReader));
			objReferencedStudySQ.addItem(objReferencedStudyItem);

			objIDataSet.addDataElement(getDataElement(0x0008,0x1110,objReferencedStudySQ.getValue(), objDictionaryReader));
		}
		objIDataSet.addDataElement(getDataElement(0x0040,0x1003,"STAT", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0040,0x1004,"Patient Transport Arrangements", objDictionaryReader));

		//Imaging Service Request
		objIDataSet.addDataElement(getDataElement(0x0008,0x0050,"Accession Number", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0032,0x1032,"Requesting Physician", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0008,0x0090,"Referring Physicians Name", objDictionaryReader));

		//Visit Identification
		objIDataSet.addDataElement(getDataElement(0x0038,0x0010,"Admission ID", objDictionaryReader));

		//Visit Status
		objIDataSet.addDataElement(getDataElement(0x0038,0x0300,"Current Patient Location", objDictionaryReader));

		//Visit Relationship
		{
			IDataTypeSQ objReferencedPatientSQ = getSQ(0x0008,0x1120, objTS);
			IItem objReferencedPatientItem = objReferencedPatientSQ.getNewItem();
			objReferencedPatientItem.addDataElement(getDataElement(0x0008,0x1150,"1.2.840.10008.5.1.4.31", objDictionaryReader));
			objReferencedPatientItem.addDataElement(getDataElement(0x0008,0x1155,"1.3.46.670589.17.1.7.1.1.11", objDictionaryReader));
			objReferencedPatientSQ.addItem(objReferencedPatientItem);

			objIDataSet.addDataElement(getDataElement(0x0008,0x1120,objReferencedPatientSQ.getValue(), objDictionaryReader));
		}

		//Patient Identification
		objIDataSet.addDataElement(getDataElement(0x0010,0x0010,"Patients Name", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0020,"Patient ID", objDictionaryReader));

		//Patient Demographic
		objIDataSet.addDataElement(getDataElement(0x0010,0x0030,"19940910", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0040,"Patients Sex", objDictionaryReader));
		{
			IDataTypeSQ objPatientPrimaryLanguageSQ = getSQ(0x0010,0x0101, objTS);
			IItem objPatientPrimaryLanguageItem = objPatientPrimaryLanguageSQ.getNewItem();
			objPatientPrimaryLanguageItem.addDataElement(getDataElement(0x0008,0x0100,"T-04000", objDictionaryReader));
			objPatientPrimaryLanguageItem.addDataElement(getDataElement(0x0008,0x0102,"C4", objDictionaryReader));
			objPatientPrimaryLanguageItem.addDataElement(getDataElement(0x0008,0x0104,"Code Meaning", objDictionaryReader));
			{
				IDataTypeSQ objPatientPrimaryLanguageCodeModifierSQ = getSQ(0x0010,0x0102, objTS);
				IItem objPatientPrimaryLanguageCodeModifierItem = objPatientPrimaryLanguageCodeModifierSQ.getNewItem();
				objPatientPrimaryLanguageCodeModifierItem.addDataElement(getDataElement(0x0008,0x0100,"T-04000", objDictionaryReader));
				objPatientPrimaryLanguageCodeModifierItem.addDataElement(getDataElement(0x0008,0x0102,"C4", objDictionaryReader));
				objPatientPrimaryLanguageCodeModifierItem.addDataElement(getDataElement(0x0008,0x0104,"Code Meaning", objDictionaryReader));
				objPatientPrimaryLanguageCodeModifierSQ.addItem(objPatientPrimaryLanguageCodeModifierItem);

				objPatientPrimaryLanguageItem.addDataElement(getDataElement(0x0010,0x0102, objPatientPrimaryLanguageCodeModifierSQ.getValue(), objDictionaryReader));
			}
			objPatientPrimaryLanguageSQ.addItem(objPatientPrimaryLanguageItem);

			objIDataSet.addDataElement(getDataElement(0x0010,0x0101,objPatientPrimaryLanguageSQ.getValue(), objDictionaryReader));
		}
		objIDataSet.addDataElement(getDataElement(0x0010,0x1030,"22", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0040,0x3001,"Confidentiality constraint on patient data", objDictionaryReader));

		//Patient Medical
		objIDataSet.addDataElement(getDataElement(0x0038,0x0500,"Patient State", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x21C0,(short)26, objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x2000,"Medical Alerts", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x2110,"Contrast Allergies", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0038,0x0050,"Special Needs", objDictionaryReader));

		//Procedure Step ProgressInformation Sequence
		{
			IDataTypeSQ objProcedureStepProgressInformationSQ = getSQ(0x0074,0x1002,objTS);
			IItem objProcedureStepProgressInformationSQItem = objProcedureStepProgressInformationSQ.getNewItem();
			objProcedureStepProgressInformationSQ.addItem(objProcedureStepProgressInformationSQItem);
			objIDataSet.addDataElement(getDataElement(0x0074,0x1002,null, objDictionaryReader));
		}
		
		return objIDataSet;
	}
	/*
	 * This function create the data element from the information provided.
	 */
	private IDataElement getDataElement(int GroupNo,int ElementNo,Object objVal,IDictionaryReader objDictionaryReader)
	{
		IDataElement objIDataElement = new ImplicitDE(GroupNo, ElementNo,objVal,objDictionaryReader);
		return objIDataElement;
	}

	/*
	 * This function gets the sequence belonging to group no and element number specified.
	 */
	private IDataTypeSQ getSQ(int GroupNo,int ElementNo , ITransferSyntax objTS)
	{
		return DicomV3Factory.createInstance().createSequence(GroupNo, ElementNo, objTS);
	}


}
